package com.jkcredit.query.record.config;

import org.apache.http.HttpHost;
import org.apache.http.auth.AuthScope;
import org.apache.http.auth.UsernamePasswordCredentials;
import org.apache.http.client.CredentialsProvider;
import org.apache.http.impl.client.BasicCredentialsProvider;
import org.elasticsearch.client.RequestOptions;
import org.elasticsearch.client.RestClient;
import org.elasticsearch.client.RestClientBuilder;
import org.elasticsearch.client.RestHighLevelClient;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * @author xusonglin
 * @version V1.0
 **/
@Configuration
public class EsConfig {
    @Value("${ElasticSearch.host}")
    private String host;
    @Value("${ElasticSearch.port}")
    private Integer port;
    @Value("${ElasticSearch.username}")
    private String username;
    @Value("${ElasticSearch.password}")
    private String password;

    public static final RequestOptions COMMON_OPTIONS;

    static {
        RequestOptions.Builder builder = RequestOptions.DEFAULT.toBuilder();
        COMMON_OPTIONS = builder.build();
    }

    @Bean
    public RestHighLevelClient esRestClient() {
        RestClientBuilder builder = null;
        // 可以指定多个es
        builder = RestClient.builder(
                new HttpHost(host, port, "http"));

        CredentialsProvider credentialsProvider = new BasicCredentialsProvider();
        credentialsProvider.setCredentials(AuthScope.ANY,
                //es账号密码
                new UsernamePasswordCredentials(username, password));
        builder.setHttpClientConfigCallback(f -> f.setDefaultCredentialsProvider(credentialsProvider));
        RestHighLevelClient client = new RestHighLevelClient(builder);
        return client;
    }

//    @Bean
//    public RestHighLevelClient esRestClient() {
//        RestClientBuilder builder = null;
//        // 可以指定多个es
//        builder = RestClient.builder(
//                new HttpHost("192.168.50.17", 9200, "http"),
//                new HttpHost("192.168.50.18", 9200, "http"),
//                new HttpHost("192.168.50.19", 9200, "http"));
//        RestHighLevelClient client = new RestHighLevelClient(builder);
//        return client;
//    }
}
