package com.jkcredit.query.record.service.impl;

import com.jkcredit.query.record.service.TokenService;
import com.jkcredit.query.record.util.JwtTokenUtil;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.Map;

/**
 * @author xusonglin
 * @version V1.0
 **/
@Service
public class TokenServiceImpl implements TokenService {
    @Value("${user.name}")
    private String userName;
    @Value("${user.key}")
    private String userKey;
    @Value("${user.secret}")
    private String userSecret;
    @Value("${user.salt}")
    private String userSalt;

    @Override
    public String getToken(String clientKey, String clientSecret) {
        Map<String, Object> claims = new HashMap<>();
        claims.put("client_key", clientKey);
        claims.put("client_secret", clientSecret);
        return JwtTokenUtil.generateToken(userName, claims, 3600, userSalt);
    }

    @Override
    public boolean validateToken(String token) {
        String subject = JwtTokenUtil.parseToken(token, userSalt);
        if (subject != null && subject.equals(userName)) {
            return true;
        } else {
            return false;
        }
    }
}
